# This is an interface definition of classes that are generated within C++.
# Used by mypy to do proper type checking of mgr modules.
# Without this file, all classes have undefined base classes.

class BasePyOSDMap(object):
    def _get_epoch(self): ...
    def _get_crush_version(self): ...
    def _dump(self):...
    def _new_incremental(self):...
    def _apply_incremental(self, inc:int):...
    def _get_crush(self):...
    def _get_pools_by_take(self, take):...
    def _calc_pg_upmaps(self, inc, max_deviation, max_iterations, pool):...
    def _map_pool_pgs_up(self, poolid):...
    def _pg_to_up_acting_osds(self, pool_id, ps):...
    def _pool_raw_used_rate(self, pool_id):...

class BasePyOSDMapIncremental(object):
    def _get_epoch(self):...
    def _dump(self):...
    def _set_osd_reweights(self, weightmap):...
    def _set_crush_compat_weight_set_weights(self, weightmap):...

class BasePyCRUSH(object):
    def _dump(self):...
    def _get_item_weight(self, item):...
    def _get_item_name(self, item):...
    def _find_takes(self):...
    def _get_take_weight_osd_map(self, root):...

class BaseMgrStandbyModule(object):
    def __init__(self, capsule): pass
    def _ceph_get_mgr_id(self):...
    def _ceph_get_module_option(self, key, prefix=None):...
    def _ceph_get_option(self, key):...
    def _ceph_get_store(self, key):...
    def _ceph_get_active_uri(self):...

class BaseMgrModule(object):
    def __init__(self, py_modules_ptr, this_ptr): pass
    def _ceph_get_version(self):...
    def _ceph_get_release_name(self):...
    def _ceph_cluster_log(self, channel, priority, message):...
    def _ceph_get_context(self):...
    def _ceph_get(self, data_name):...
    def _ceph_get_server(self, hostname):...
    def _ceph_get_perf_schema(self, svc_type, svc_name):...
    def _ceph_get_counter(self, svc_type, svc_name, path):...
    def _ceph_get_latest_counter(self, svc_type, svc_name, path):...
    def _ceph_get_metadata(self, svc_type, svc_id):...
    def _ceph_get_daemon_status(self, svc_type, svc_id):...
    def _ceph_send_command(self, result, svc_type, svc_id, command, tag, inbuf):...
    def _ceph_set_health_checks(self, checks):...
    def _ceph_get_mgr_id(self):...
    def _ceph_get_option(self, key):...
    def _ceph_get_module_option(self, key, default, localized_prefix=""):...
    def _ceph_get_store_prefix(self, key_prefix):...
    def _ceph_set_module_option(self, module, key, val):...
    def _ceph_set_store(self, key, val):...
    def _ceph_get_store(self, key):...
    def _ceph_get_osdmap(self):...
    def _ceph_set_uri(self, uri):...
    def _ceph_have_mon_connection(self):...
    def _ceph_update_progress_event(self, evid, desc, progress):...
    def _ceph_complete_progress_event(self, evid):...
    def _ceph_clear_all_progress_events(self):...
    def _ceph_dispatch_remote(self, module_name, method_name, *args, **kwargs):...
    def _ceph_add_osd_perf_query(self, query):...
    def _ceph_remove_osd_perf_query(self, query_id):...
    def _ceph_get_osd_perf_counters(self, query_id):...
    def _ceph_unregister_client(self, addrs):...
    def _ceph_register_client(self, addrs):...
    def _ceph_is_authorized(self, arguments):...
